const int sensorLeft = A4;
const int sensorRight = A5;


#include <SoftPWM.h>
#define ENA A0  // Left motor enable (PWM)
#define ENB A3  // Right motor enable (PWM)
#define in1 A2  // Left motor direction
#define in2 A1  // Left motor direction
#define in3 5   // Right motor direction
#define in4 6   // Right motor direction
int leftSpeed = 0;
int rightSpeed = 0;

int topSpeed = 60;
int Speed = 35;
int minSpeed = -60;

int turn = 0;
int turnstop = 300;

int sensorTheshold = 400;


void setup() {
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  pinMode(ENA, OUTPUT);
  pinMode(ENB, OUTPUT);
  Serial.begin(115200);

  pinMode(sensorLeft, INPUT);
  pinMode(sensorRight, INPUT);

  SoftPWMBegin();
  SoftPWMSet(ENA, 0); // Start with 0 speed
  SoftPWMSet(ENB, 0);

  SoftPWMSetFadeTime(ENA, 50, 50);
  SoftPWMSetFadeTime(ENB, 50, 50);

  delay(3000);
}

void loop() { 
  int left = analogRead(sensorLeft);
  int right = analogRead(sensorRight);
  Serial.print("Left Sensor: ");
  Serial.print(analogRead(sensorLeft));
  Serial.print(" Right Sensor: ");
  Serial.println(right);

  if (left > sensorTheshold && right > sensorTheshold) {
    if (turn == 1) {
      setLeftMotorSpeed(0);
      setRightMotorSpeed(0);
      delay(turnstop);
    }
    turn = 0;

    setLeftMotorSpeed(Speed);
    setRightMotorSpeed(Speed);
  }
  else if (left < sensorTheshold && right > sensorTheshold){
    turn = 1;

    setLeftMotorSpeed(minSpeed);
    setRightMotorSpeed(topSpeed);
  }
  else if (left > sensorTheshold && right < sensorTheshold){
    turn = 1;

    setLeftMotorSpeed(topSpeed);
    setRightMotorSpeed(minSpeed);
  }
  else {
    if (turn == 1) {
      setLeftMotorSpeed(0);
      setRightMotorSpeed(0);
      delay(turnstop);
    }
    turn = 0;

    setLeftMotorSpeed(Speed);
    setRightMotorSpeed(Speed);
  }
    
  delay(20); // Small delay for readability
}

void setLeftMotorSpeed(int x) {
  x = map(x, -100, 100, -225, 225);
  if (x > 0) {  // Forward
    digitalWrite(in1, HIGH);
    digitalWrite(in2, LOW);
  } else if (x < 0) {  // Backward
    digitalWrite(in1, LOW);
    digitalWrite(in2, HIGH);
  } else {  // Stop
    digitalWrite(in1, LOW);
    digitalWrite(in2, LOW);
  }
  SoftPWMSet(ENA, abs(x));
}

void setRightMotorSpeed(int x) {
  x = map(x, -100, 100, -225, 225);
  if (x > 0) {  // Forward
    digitalWrite(in3, LOW);
    digitalWrite(in4, HIGH);
  } else if (x < 0) {  // Backward
    digitalWrite(in3, HIGH);
    digitalWrite(in4, LOW);
  } else {  // Stop
    digitalWrite(in3, LOW);
    digitalWrite(in4, LOW);
  }
  SoftPWMSet(ENB, abs(x));
}